/*************************************************
 gba rom dump script
*************************************************/
function cpu_dump(d, rom_size, banksize)
{
	for(local i = 0; i < rom_size; i += 0x10000){
		cpu_read(d, i, 0x10000);//read 64k a time
	}
}
function cpu_erase(d, rom_size, banksize)
{
	local m_29f_flash = 0;
	local m_29lv_flash = 1;
	
	local flash_chip_type = m_29lv_flash;
	//change to m_29f_flash here, if your gb 
	//flash chip is 29f(mx29f016,amd29f016,amd29f080...)
	
	//detect chip here
	if(flash_chip_type==m_29f_flash)
	{
		cpu_write(0x555,0xF0);

		cpu_write(0x555,0xAA);
		cpu_write(0x2AA,0x55);
		cpu_write(0x555,0x80);

		cpu_write(0x555,0xAA);
		cpu_write(0x2AA,0x55);
		cpu_write(0x555,0x10);
	}
	else{
	//erase mx29lv320 
	cpu_write(d,0xAAA,0xF0);

	cpu_write(d,0xAAA,0xAA);
	cpu_write(d,0x555,0x55);
	cpu_write(d,0xAAA,0x80);
	cpu_write(d,0xAAA,0xAA);
	cpu_write(d,0x555,0x55);
	cpu_write(d,0xAAA,0x10);	
	}
	rom_flash_cfg(d,flash_chip_type);
}
function cpu_flash(d, rom_size, banksize)
{
	for(local i = 0; i < rom_size/0x4000; i += 1)
	{
		cpu_write(d, 0x3000, i>>8, 0x2000, i&0xFF);
		rom_write (d, 0x4000, 0x4000);
	}
}
function save_dump(d, save_size, max_size)
{
	for(local i = 0; i < save_size; i += 0x400)
	{
		ram_read (d, i, 0x400); 
	}
}
function save_erase(d, save_size, save_type)
{
	//not need here
	ram_erase(d);
}
function save_write(d, save_size, max_size)
{
	for(local i = 0; i < save_size; i += 0x400)
	{
		ram_write (d, i, 0x400); 
	}
}